/*
 * 机具回收申请
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class RecycMachineOrderController : BaseController
    {
        public RecycMachineOrderController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 机具回收申请列表

        /// <summary>
        /// 根据条件查询机具回收申请列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(RecycMachineOrder data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询机具回收申请列表

        /// <summary>
        /// 机具回收申请列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(RecycMachineOrder data, string UserIdMakerCode, string UserIdRealName, string RecycStoreIdStoreNo, string PostTypeSelect, string BrandIdSelect, string CreateDateData, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("ErpName", "1"); //快递名称
            Fields.Add("ErpCode", "1"); //快递单号
            Fields.Add("RecycOrderNo", "1"); //申请单号


            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //退回仓库编号
            if (!string.IsNullOrEmpty(RecycStoreIdStoreNo))
            {
                condition += " and RecycStoreId in (select StoreId from StoreForCode where Code='" + RecycStoreIdStoreNo + "')";
            }
            //寄回方式
            if (!string.IsNullOrEmpty(PostTypeSelect))
            {
                condition += " and PostType=" + PostTypeSelect;
            }
            //机具品牌
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and CreateDate>='" + start + " 00:00:00' and CreateDate<='" + end + " 23:59:59'";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("RecycMachineOrder", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //退回仓库
                int RecycStoreId = int.Parse(function.CheckInt(dic["RecycStoreId"].ToString()));
                StoreHouse recycstoreid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == RecycStoreId) ?? new StoreHouse();
                dic["RecycStoreIdStoreNo"] = recycstoreid_StoreHouse.StoreNo;
                dic["RecycStoreIdStoreName"] = recycstoreid_StoreHouse.StoreName;
                dic["RecycStoreIdManageMobile"] = recycstoreid_StoreHouse.ManageMobile;
                dic.Remove("RecycStoreId");
                //寄回方式
                int PostType = int.Parse(dic["PostType"].ToString());
                if (PostType == 1) dic["PostType"] = "邮寄";
                if (PostType == 2) dic["PostType"] = "送货上门";
                if (PostType == 0) dic["PostType"] = "";
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加机具回收申请

        /// <summary>
        /// 增加或修改机具回收申请信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加机具回收申请

        /// <summary>
        /// 增加或修改机具回收申请信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(RecycMachineOrder data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("RecycStoreId", data.RecycStoreId); //退回仓库
            Fields.Add("PostType", data.PostType); //寄回方式
            Fields.Add("ErpName", data.ErpName); //快递名称
            Fields.Add("ErpCode", data.ErpCode); //快递单号

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("RecycMachineOrder", Fields, 0);
            AddSysLog(data.Id.ToString(), "RecycMachineOrder", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改机具回收申请

        /// <summary>
        /// 增加或修改机具回收申请信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            RecycMachineOrder editData = db.RecycMachineOrder.FirstOrDefault(m => m.Id == Id) ?? new RecycMachineOrder();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改机具回收申请

        /// <summary>
        /// 增加或修改机具回收申请信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(RecycMachineOrder data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("RecycStoreId", data.RecycStoreId); //退回仓库
            Fields.Add("PostType", data.PostType); //寄回方式
            Fields.Add("ErpName", data.ErpName); //快递名称
            Fields.Add("ErpCode", data.ErpCode); //快递单号

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("RecycMachineOrder", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "RecycMachineOrder", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除机具回收申请信息

        /// <summary>
        /// 删除机具回收申请信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "RecycMachineOrder", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("RecycMachineOrder", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "RecycMachineOrder", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("RecycMachineOrder", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "RecycMachineOrder", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("RecycMachineOrder", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("RecycMachineOrder", Sort, Id);

            AddSysLog(Id.ToString(), "RecycMachineOrder", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.RecycMachineOrder.Add(new RecycMachineOrder()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "RecycMachineOrder", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(RecycMachineOrder data, string UserIdMakerCode, string UserIdRealName, string RecycStoreIdStoreNo, string RecycStoreIdStoreName, string RecycStoreIdManageMobile, string PostTypeSelect, string BrandIdSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("ErpName", "1"); //快递名称
            Fields.Add("ErpCode", "1"); //快递单号
            Fields.Add("RecycOrderNo", "1"); //申请单号


            string condition = " and Status>-1";
            //创客创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //退回仓库仓库编号
            if (!string.IsNullOrEmpty(RecycStoreIdStoreNo))
            {
                condition += " and RecycStoreId in (select RecycStoreId from StoreHouseForStoreNo where StoreNo='" + RecycStoreIdStoreNo + "')";
            }
            //退回仓库仓库名称
            if (!string.IsNullOrEmpty(RecycStoreIdStoreName))
            {
                condition += " and RecycStoreId in (select RecycStoreId from StoreHouseForStoreName where StoreName='" + RecycStoreIdStoreName + "')";
            }
            //退回仓库管理者手机号
            if (!string.IsNullOrEmpty(RecycStoreIdManageMobile))
            {
                condition += " and RecycStoreId in (select RecycStoreId from StoreHouseForManageMobile where ManageMobile='" + RecycStoreIdManageMobile + "')";
            }
            //寄回方式
            if (!string.IsNullOrEmpty(PostTypeSelect))
            {
                condition += " and PostType=" + PostTypeSelect;
            }
            //机具品牌
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("RecycMachineOrder", Fields, "Id desc", "0", 1, 20000, condition, "UserId,RecycStoreId,PostType,ErpName,ErpCode,ResultDate,CancelDate,RecycOrderNo", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //退回仓库
                int RecycStoreId = int.Parse(function.CheckInt(dic["RecycStoreId"].ToString()));
                StoreHouse recycstoreid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == RecycStoreId) ?? new StoreHouse();
                dic["RecycStoreIdStoreNo"] = recycstoreid_StoreHouse.StoreNo;
                dic["RecycStoreIdStoreName"] = recycstoreid_StoreHouse.StoreName;
                dic["RecycStoreIdManageMobile"] = recycstoreid_StoreHouse.ManageMobile;
                dic.Remove("RecycStoreId");
                //寄回方式
                int PostType = int.Parse(dic["PostType"].ToString());
                if (PostType == 1) dic["PostType"] = "邮寄";
                if (PostType == 2) dic["PostType"] = "送货上门";
                if (PostType == 0) dic["PostType"] = "";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("UserIdMakerCode", "创客创客编号");
            ReturnFields.Add("UserIdRealName", "创客真实姓名");
            ReturnFields.Add("RecycStoreIdStoreNo", "退回仓库仓库编号");
            ReturnFields.Add("RecycStoreIdStoreName", "退回仓库仓库名称");
            ReturnFields.Add("RecycStoreIdManageMobile", "退回仓库管理者手机号");
            ReturnFields.Add("PostType", "寄回方式");
            ReturnFields.Add("ErpName", "快递名称");
            ReturnFields.Add("ErpCode", "快递单号");
            ReturnFields.Add("ResultDate", "确认或驳回时间");
            ReturnFields.Add("CancelDate", "创客撤销时间");
            ReturnFields.Add("RecycOrderNo", "申请单号");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "RecycMachineOrder", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
